<?php
/*******************************************************************************************************************
 * Database Tools for XAseco v1.1.4 / XAseco2 v1.0.0
 * v1.0.2
 * by vni
 * Attention: This plugin comes with absolutely no warranty. Use it at your own risk. Always make a backup
 * 			  of your database before doing anything here! Copied that? Thanks.
 ********************************************************************************************************************/

/***********************************
 * Xaseco-Events
 ***********************************/
	Aseco::registerEvent('onSync',							'dbtools_event_sync');
    Aseco::addChatCommand('dbtools',  						'DBTools Commands');
/***********************************
 * Initialization
 ***********************************/
	global $dbtools;
    $dbtools['version_string'] = '1.0.2';
	$dbtools['chatprefix'] = '$F00DBTools$F90>> $FFF ';
	
function dbtools_event_sync($aseco)
{
	global $dbtools;
}	

function dbtools_chat($aseco, $message, $login = false)
{
	global $dbtools;
	if ($login)
	{
		$aseco->client->query('ChatSendServerMessageToLogin', $dbtools['chatprefix'].$message , $login);
	}
	else
	{
		$aseco->client->query('ChatSendServerMessage', $dbtools['chatprefix'].$message);
	}

}

function dbtools_sql($query)
{
	$result_sql = @mysql_query($query);
	return @mysql_fetch_assoc($result_sql);
}

function chat_dbtools($aseco, $command)
{
    global $dbtools;
	if ($aseco->isMasterAdmin($command['author']))
    {
		$param = explode(' ',$command['params']);
		
        if (strtolower($param[0]) == 'help')
        {
			dbtools_chat($aseco, '', $command['author']->login);
			dbtools_chat($aseco, 'DBTOOLS v'.$dbtools['version_string'].' by vni', $command['author']->login);
			dbtools_chat($aseco, 'Attention: DB-Tools comes with absolutely no warranty. Make a backup of your database first!', $command['author']->login);
			dbtools_chat($aseco, 'The following commands are available:', $command['author']->login);
			dbtools_chat($aseco, '$ADF/dbtools help $FFF- This info', $command['author']->login);
			dbtools_chat($aseco, '$ADF/dbtools cleanupdb $FFF- Remove old tracks/records from the database', $command['author']->login);
			dbtools_chat($aseco, '$ADF/dbtools optimize $FFF- Optimizes your database', $command['author']->login);
			dbtools_chat($aseco, '$ADF/dbtools repair $FFF- Repair your database', $command['author']->login);
			dbtools_chat($aseco, '$ADF/dbtools wipedb $FFF- Wipes the complete database', $command['author']->login);
			dbtools_chat($aseco, '$ADF/dbtools removelogin <LOGIN> $FFF- Removed all records of <LOGIN>', $command['author']->login);
			dbtools_chat($aseco, '$ADF/dbtools removethis $FFF- Removes all records/votes of the current track', $command['author']->login);
			dbtools_chat($aseco, '$ADF/dbtools clearstyles $FFF- Resets all custom styling', $command['author']->login);
			dbtools_chat($aseco, '$ADF/dbtools clearplaytime [<LOGIN>] $FFF- Clears the playtime of all or of <LOGIN>', $command['author']->login);
			dbtools_chat($aseco, '$ADF/dbtools clearwins [<LOGIN>] $FFF- Clears the wins of all or of <LOGIN>', $command['author']->login);
			dbtools_chat($aseco, '$ADF/dbtools backup [<FILENAME>] $FFF- Creates a backup of the database', $command['author']->login);
			dbtools_chat($aseco, '$ADF/dbtools restore [<FILENAME>] $FFF- Restores a database-backup', $command['author']->login);
        }
        elseif (strtolower($param[0]) == 'wipedb')
        {
			dbtools_chat($aseco, 'Wiping the database...', $command['author']->login);
			dbtools_sql('TRUNCATE TABLE maps');
			dbtools_sql('TRUNCATE TABLE challenges');
			dbtools_sql('TRUNCATE TABLE players');
			dbtools_sql('TRUNCATE TABLE players_extra');
			dbtools_sql('TRUNCATE TABLE records');
			dbtools_sql('TRUNCATE TABLE rs_karma');
			dbtools_sql('TRUNCATE TABLE rs_rank');
			dbtools_sql('TRUNCATE TABLE rs_times');
			dbtools_chat($aseco, 'Wipe complete. You should restart Xaseco now.', $command['author']->login);
        }
        elseif (strtolower($param[0]) == 'optimize')
        {
			dbtools_chat($aseco, 'Optimizing the database...', $command['author']->login);
			dbtools_sql('OPTIMIZE TABLE maps');
			dbtools_sql('OPTIMIZE TABLE challenges');
			dbtools_sql('OPTIMIZE TABLE players');
			dbtools_sql('OPTIMIZE TABLE players_extra');
			dbtools_sql('OPTIMIZE TABLE records');
			dbtools_sql('OPTIMIZE TABLE rs_karma');
			dbtools_sql('OPTIMIZE TABLE rs_rank');
			dbtools_sql('OPTIMIZE TABLE rs_times');
			dbtools_chat($aseco, 'Optimization complete.', $command['author']->login);
        }
        elseif (strtolower($param[0]) == 'repair')
        {
			dbtools_chat($aseco, 'Repairing the database...', $command['author']->login);
			dbtools_sql('REPAIR TABLE maps');
			dbtools_sql('REPAIR TABLE challenges');
			dbtools_sql('REPAIR TABLE players');
			dbtools_sql('REPAIR TABLE players_extra');
			dbtools_sql('REPAIR TABLE records');
			dbtools_sql('REPAIR TABLE rs_karma');
			dbtools_sql('REPAIR TABLE rs_rank');
			dbtools_sql('REPAIR TABLE rs_times');
			dbtools_chat($aseco, 'Repair complete.', $command['author']->login);
        }
        elseif (strtolower($param[0]) == 'backup')
        {
			if (ini_get('safe_mode'))
			{
				dbtools_chat($aseco, 'Sorry, the PHP-Safe-Mode is on - It is not possible to create a backup', $command['author']->login);
			}
			else
			{
				if (strtoupper(substr(PHP_OS, 0, 5)) != 'LINUX') 
				{
					dbtools_chat($aseco, 'Sorry, the backup feature is available on Linux-Systems only', $command['author']->login);
				}			
				else
				{
					//Load the database settings
					$localdatabase = simplexml_load_file('localdatabase.xml');
					
					if ((strtolower($localdatabase->mysql_server) != 'localhost') && (strtolower($localdatabase->mysql_server) != '127.0.0.1'))
					{
						dbtools_chat($aseco, 'Sorry, the backup feature is available for local databases only', $command['author']->login);
					}
					else
					{
						dbtools_chat($aseco, 'Creating Backup...', $command['author']->login);
						if (!chop($param[1])) $filename = 'dbtools_dump.sql';
						else $filename = chop($param[1]);
						exec ('mysqldump -h localhost -u '.$localdatabase->mysql_login.' -p'.$localdatabase->mysql_password.' '.$localdatabase->mysql_database.' >'.$filename);
						dbtools_chat($aseco, 'Backup created. Filename: '.$filename, $command['author']->login);
					}
				}
			}		
        }
        elseif (strtolower($param[0]) == 'restore')
        {
			if (ini_get('safe_mode'))
			{
				dbtools_chat($aseco, 'Sorry, the PHP-Safe-Mode is on - It is not possible to restore a backup', $command['author']->login);
			}
			else
			{
				if (strtoupper(substr(PHP_OS, 0, 5)) != 'LINUX') 
				{
					dbtools_chat($aseco, 'Sorry, the backup feature is available on Linux-Systems only', $command['author']->login);
				}			
				else
				{
					//Load the database settings
					$localdatabase = simplexml_load_file('localdatabase.xml');
					
					if ((strtolower($localdatabase->mysql_server) != 'localhost') && (strtolower($localdatabase->mysql_server) != '127.0.0.1'))
					{
						dbtools_chat($aseco, 'Sorry, the backup feature is available for local databases only', $command['author']->login);
					}
					else
					{
						if (!chop($param[1])) $filename = 'dbtools_dump.sql';
						else $filename = chop($param[1]);
						
						if (!file_exists($filename))
						{
							dbtools_chat($aseco, 'The file '.$filename.' can not be found.', $command['author']->login);
						}
						else
						{
							dbtools_chat($aseco, 'Wiping the current database...', $command['author']->login);
							dbtools_sql('TRUNCATE TABLE maps');
							dbtools_sql('TRUNCATE TABLE challenges');
							dbtools_sql('TRUNCATE TABLE players');
							dbtools_sql('TRUNCATE TABLE players_extra');
							dbtools_sql('TRUNCATE TABLE records');
							dbtools_sql('TRUNCATE TABLE rs_karma');
							dbtools_sql('TRUNCATE TABLE rs_rank');
							dbtools_sql('TRUNCATE TABLE rs_times');
							dbtools_chat($aseco, 'Restoring Backup...', $command['author']->login);
							exec ('mysql --verbose --user='.$localdatabase->mysql_login.' --password='.$localdatabase->mysql_password.' '.$localdatabase->mysql_database.' < '.$filename);
							dbtools_chat($aseco, 'Backup restored. Restart XAseco!', $command['author']->login);
							$aseco->client->query('SendHideManialinkPage');
							die("Closed by DBTool-Restore.");
						}
					}
				}
			}		
        }
        elseif (strtolower($param[0]) == 'clearplaytime')
        {
			if ($param[1])
			{
				dbtools_sql('UPDATE players SET TimePlayed = 0 WHERE Login="'.mysql_real_escape_string($param[1]).'"');
				dbtools_chat($aseco, 'Playtime cleared for login '.$param[1], $command['author']->login);
			}
			else
			{
				dbtools_sql('UPDATE players SET TimePlayed = 0');
				dbtools_chat($aseco, 'Playtime cleared for all logins.', $command['author']->login);
			}
        }
        elseif (strtolower($param[0]) == 'clearstyles')
        {
			dbtools_sql('UPDATE players_extra SET Style="NavBlueBlur", Panels="AdminRightCorner/DonateBelowCPList/RecordsRightCorner/VoteBottomCenter", PanelBG="PanelBGCard"');
			dbtools_chat($aseco, 'Styles cleared.', $command['author']->login);
        }
        elseif (strtolower($param[0]) == 'clearwins')
        {
			if ($param[1])
			{
				dbtools_sql('UPDATE players SET Wins = 0 WHERE Login="'.mysql_real_escape_string($param[1]).'"');
				dbtools_chat($aseco, 'Wins cleared for login '.$param[1], $command['author']->login);
			}
			else
			{
				dbtools_sql('UPDATE players SET Wins = 0');
				dbtools_chat($aseco, 'Wins cleared for all logins.', $command['author']->login);
			}
        }
        elseif (strtolower($param[0]) == 'removethis')
        {
			$aseco->client->query('GetCurrentChallengeInfo');
			$challengeinfo = $aseco->client->getResponse();
			
			if ($aseco->server->getGame() == 'MP') $challengedata = dbtools_sql('SELECT * FROM maps WHERE Uid = "'.mysql_real_escape_string($challengeinfo['UId']).'"');
			else $challengedata = dbtools_sql('SELECT * FROM challenges WHERE Uid = "'.mysql_real_escape_string($challengeinfo['UId']).'"');
			
			if ($challengedata)
			{
				dbtools_chat($aseco, 'Removing challenge '.$challengedata['Name'], $command['author']->login);
				
				//TM2
				dbtools_sql('DELETE FROM records WHERE MapId='.(int)$challengedata['Id']);
				dbtools_sql('DELETE FROM rs_karma WHERE MapId='.(int)$challengedata['Id']);
				dbtools_sql('DELETE FROM rs_times WHERE MapId='.(int)$challengedata['Id']);
				//TMF
				dbtools_sql('DELETE FROM records WHERE ChallengeId='.(int)$challengedata['Id']);
				dbtools_sql('DELETE FROM rs_karma WHERE ChallengeId='.(int)$challengedata['Id']);
				dbtools_sql('DELETE FROM rs_times WHERE ChallengeId='.(int)$challengedata['Id']);


				if ($aseco->server->getGame() == 'MP') dbtools_sql('DELETE FROM maps WHERE Id='.(int)$challengedata['Id']);
				else dbtools_sql('DELETE FROM challenges WHERE Id='.(int)$challengedata['Id']);
				dbtools_chat($aseco, 'Challenge removed. You should restart Xaseco now.', $command['author']->login);
			}
			else
			{
				dbtools_chat($aseco, 'No challengedata available. Oops?', $command['author']->login);
			}
			
        }
        elseif (strtolower($param[0]) == 'removelogin')
        {
			if ($param[1])
			{
				$playerdata = dbtools_sql('SELECT * FROM players WHERE Login = "'.mysql_real_escape_string($param[1]).'"');
				
				if ($playerdata)
				{
					dbtools_chat($aseco, 'Removing all records of player '.$param[1], $command['author']->login);
					dbtools_chat($aseco, 'Player '.$param[1].' found (Id='.$playerdata['Id'].').', $command['author']->login);
					
					dbtools_chat($aseco, 'Removing records of '.$param[1], $command['author']->login);
					dbtools_sql('DELETE FROM records WHERE PlayerId='.(int)$playerdata['Id']);
					
					dbtools_chat($aseco, 'Removing Karma-Votes of '.$param[1], $command['author']->login);
					dbtools_sql('DELETE FROM rs_karma WHERE PlayerId='.(int)$playerdata['Id']);
					
					dbtools_chat($aseco, 'Removing Ranks of '.$param[1], $command['author']->login);
					dbtools_sql('DELETE FROM rs_rank WHERE PlayerId='.(int)$playerdata['Id']);
					
					dbtools_chat($aseco, 'Removing detailed times of '.$param[1], $command['author']->login);
					dbtools_sql('DELETE FROM rs_times WHERE PlayerId='.(int)$playerdata['Id']);
					
					dbtools_chat($aseco, 'Removing Player-Data of '.$param[1], $command['author']->login);
					dbtools_sql('DELETE FROM players WHERE Id='.(int)$playerdata['Id']);
					dbtools_sql('DELETE FROM players_extra WHERE PlayerId='.(int)$playerdata['Id']);
					
					dbtools_chat($aseco, 'Done. You should restart Xaseco now.', $command['author']->login);
				}
				else
				{
					dbtools_chat($aseco, 'Player '.$param[1].' not found.', $command['author']->login);
					return;
				}
			}
			else
			{
				dbtools_chat($aseco, 'You must specify a login: /dbtools removelogin <LOGIN>', $command['author']->login);
			}
        }
        elseif (strtolower($param[0]) == 'cleanupdb')
        {
			dbtools_chat($aseco, 'Cleaning the database...', $command['author']->login);
			
			//Challenges auf dem Server
				$aseco->client->query('GetChallengeList', 2650, 0);
				$serverchallenges = $aseco->client->getResponse();
				$sc_array = array();
				foreach ($serverchallenges as $challenge)
				{
					$sc_array[$challenge['UId']] = $challenge;
				}

			//Challenges in der Datenbank
				if ($tmsorg['game'] == 'MP') $query = 'SELECT * FROM maps;';
				else $query = 'SELECT * FROM challenges;';
				
				
				$result_sql = mysql_query($query);
				$i=0;
				while($result_assoc_line = mysql_fetch_assoc($result_sql))
				{
					foreach($result_assoc_line as $key => $value)
					{
						$dbchallenges[$i][$key]=$value;
					};
					$i++;
				}
				
				foreach ($dbchallenges as $challenge)
				{
					if (!$sc_array[$challenge['Uid']])
					{
						dbtools_chat($aseco, 'Cleaning Track ID #'.$challenge['Id'].': '.$challenge['Name'], $command['author']->login);

						if ($tmsorg['game'] == 'MP') $query = 'DELETE FROM maps WHERE Uid="'.$challenge['Uid'].'";';
						else $query = 'DELETE FROM challenges WHERE Uid="'.$challenge['Uid'].'";';
						$result_sql = mysql_query($query);
						
						if ($tmsorg['game'] == 'MP') $query = 'DELETE FROM records WHERE MapId="'.$challenge['Id'].'";';
						else $query = 'DELETE FROM records WHERE ChallengeId="'.$challenge['Id'].'";';
						$result_sql = mysql_query($query);
						
						if ($tmsorg['game'] == 'MP') $query = 'DELETE FROM rs_karma WHERE MapId="'.$challenge['Id'].'";';
						else $query = 'DELETE FROM rs_karma WHERE ChallengeId="'.$challenge['Id'].'";';
						$result_sql = mysql_query($query);
						
						if ($tmsorg['game'] == 'MP') $query = 'DELETE FROM rs_times WHERE MapId="'.$challenge['Id'].'";';
						else $query = 'DELETE FROM rs_times WHERE ChallengeId="'.$challenge['Id'].'";';
						$result_sql = mysql_query($query);
					}
				}
				
				dbtools_chat($aseco, 'Cleanup done. XAseco is now shutting down. Restart XAseco!', $command['author']->login);
				$aseco->client->query('SendHideManialinkPage');
				die("Closed by DBTool-Cleanup.");
        }
        else
        {
			dbtools_chat($aseco, 'Type $CCC/dbtools help$FFF for more information '.$param[1], $command['author']->login);
        }
    }
    else{
		dbtools_chat($aseco, 'This command is available to MasterAdmins only!', $command['author']->login);
    }
}


?>